import mongoose, { Mongoose } from 'mongoose';
export declare abstract class DbConnect {
    abstract get mongoose(): Mongoose;
    abstract get dbConnectionString(): string;
    abstract set dbConnectionString(connectionStr: string);
    abstract connect(): Promise<boolean>;
}
export declare class MongooseConnect extends DbConnect {
    private static _instance;
    private isRequired;
    private _mongoose;
    private _dbConnectionString;
    private constructor();
    static getInstance(): MongooseConnect;
    get mongoose(): typeof mongoose;
    get dbConnectionString(): string;
    set dbConnectionString(connectionStr: string);
    connect(): Promise<boolean>;
}
